/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import {exists, mapValues} from '../runtime';
/**
 *
 * @export
 * @interface TransactionMessageCollateralDto
 */
export interface TransactionMessageCollateralDto {
  /**
   *
   * @type {string}
   * @memberof TransactionMessageCollateralDto
   */
  type: TransactionMessageCollateralDtoTypeEnum;
  /**
   *
   * @type {number}
   * @memberof TransactionMessageCollateralDto
   */
  amount: number;
  /**
   *
   * @type {number}
   * @memberof TransactionMessageCollateralDto
   */
  exchangePrice?: number;
  /**
   *
   * @type {string}
   * @memberof TransactionMessageCollateralDto
   */
  exchangeCurrency?: string;
  /**
   *
   * @type {string}
   * @memberof TransactionMessageCollateralDto
   */
  tokenSymbol?: string;
}

/**
 * @export
 */
export const TransactionMessageCollateralDtoTypeEnum = {
  Native: 'NATIVE',
  Erc20: 'ERC20',
} as const;
export type TransactionMessageCollateralDtoTypeEnum =
  typeof TransactionMessageCollateralDtoTypeEnum[keyof typeof TransactionMessageCollateralDtoTypeEnum];

export function TransactionMessageCollateralDtoFromJSON(
  json: any
): TransactionMessageCollateralDto {
  return TransactionMessageCollateralDtoFromJSONTyped(json, false);
}

export function TransactionMessageCollateralDtoFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): TransactionMessageCollateralDto {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    type: json['type'],
    amount: json['amount'],
    exchangePrice: !exists(json, 'exchangePrice')
      ? undefined
      : json['exchangePrice'],
    exchangeCurrency: !exists(json, 'exchangeCurrency')
      ? undefined
      : json['exchangeCurrency'],
    tokenSymbol: !exists(json, 'tokenSymbol') ? undefined : json['tokenSymbol'],
  };
}

export function TransactionMessageCollateralDtoToJSON(
  value?: TransactionMessageCollateralDto | null
): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    type: value.type,
    amount: value.amount,
    exchangePrice: value.exchangePrice,
    exchangeCurrency: value.exchangeCurrency,
    tokenSymbol: value.tokenSymbol,
  };
}
